Create Multiple Document Versions
Create or add document versions in bulk.
- The maximum CSV input file size is 1GB.
- The values in the input must be UTF-8 encoded.
- CSVs must follow the standard RFC 4180 format, with some exceptions.
- The maximum batch size is 500.
POST
/api/{version}/objects/documents/versions/batchHeaders
Section link for Headers| Name | Description |
|---|---|
Content-Type | text/csv |
Accept | application/json (default) or text/csv |
X-VaultAPI-MigrationMode | Must be set to true. Vault relaxes field validation to support document migration. You must have the Document Migration permission to use this header. Learn more about Document Migration Mode. |
X-VaultAPI-NoTriggers | If set to true and Document Migration Mode |
About Document Migration Mode
Section link for About Document Migration ModeWith the X-VaultAPI-MigrationMode header, Vault relaxes field validation to support document migration.
When this header is set to true, Vault:
- Does not enforce requiredness validation on document fields.
- Does not enforce Dynamic Reference Constraint (DRC) validation.
- Bypasses entry criteria, entry actions, and event actions.
- Does not send notifications.
Additionally, developers can:
- Create document versions in any lifecycle state, including inactive states, using the
status__vfield. - Assign an inactive document type or lifecycle.
- Manually set the name and version number.
- Set lookup field values directly. Vault recalculates a lookup field only when you update one of its source fields.
- Set
created_by__v,document_creation_date__v,last_modified_by__v, andversion_modified_date__v.
You must have the Vault Owner Actions: Document Migration permission to use this header. Learn more about Document Migration Mode
Body Parameters
Section link for Body Parameters| Name | Description |
|---|---|
filerequired | The filepath of your source file. The maximum allowed file size is 500GB. |
idconditional | The system-assigned document ID of the document to add the versions to. Not required if providing a unique field identifier (idParam) such as external_id__v. |
external_id__vconditional | Instead of id, you can use this user-defined document external ID. |
name__vrequired | Enter a name for the new document. This may be the same name as the existing document/version or a different name. |
type__vrequired | Enter the name or label of the document type to assign to the new document. |
subtype__voptional | Enter the name or label of the document subtype (if one exists on the document type). |
classification__voptional | Enter the name or label of the document classification (if one exists on the document subtype). |
lifecycle__vrequired | Enter the name or label of the document lifecycle to assign to the new document. This may be the same lifecycle as the existing document/version or a different lifecycle. |
major_version_number__vrequired | Enter the major version number to assign to the new document version. This must be a version that does not yet exist on the document being updated. |
minor_version_number__vrequired | Enter the minor version number to assign to the new document. This must be a version that does not yet exist on the document being updated. |
status__vrequired | Enter the name or label of the status for the new document, e.g., Draft, In Review, Approved, etc. |
product__voptional | Example: This is an example object reference field. To assign value for this field type, include either the document field name product__v or the document field name plus the name field on the object product__v.name__v. |
Query Parameters
Section link for Query Parameters| Name | Description |
|---|---|
idParam | If you're identifying documents in your input by a unique field, add idParam={fieldname} to the request endpoint. You can use any object field which has unique set to true in the object metadata, with the exception of picklists. For example, idParam=external_id__v. |
Note: In PromoMats Vaults with Automated Claims Linking enabled, when a reference document is updated with the Create Multiple Document Versions API, the associated claim record is updated to reference the new version and remains in the approved state, and the reference is not removed.
Request
Section link for Requestcurl -X POST -H "Authorization: {AUTH_VALUE}" \
-H "Content-Type: text/csv" \
-H "Accept: text/csv" \
--data-binary @"filename" \
https://myvault.veevavault.com/api/v26.3/objects/documents/versions/batchResponse
Section link for Response{
"responseStatus": "SUCCESS",
"data": [
{
"responseStatus": "SUCCESS",
"id": 771,
"external_id__v": "ALT-DOC-0771",
"major_version_number__v": 0,
"minor_version_number__v": 2
},
{
"responseStatus": "SUCCESS",
"id": 772,
"external_id__v": "CHO-DOC-0772",
"major_version_number__v": 0,
"minor_version_number__v": 2
},
{
"responseStatus": "SUCCESS",
"id": 773,
"external_id__v": "GLU-DOC-0773",
"major_version_number__v": 1,
"minor_version_number__v": 0
},
{
"responseStatus": "FAILURE",
"errors": [
{
"type": "INVALID_DATA",
"message": "Error message describing why this document version was not added."
}
]
}
]
}